# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

# [5.0.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.2.2...@ionic/cli-framework@5.0.0) (2020-08-27)


### Code Refactoring

* do not re-export from @ionic/cli-framework-output ([a91b5a4](https://github.com/ionic-team/ionic-cli/commit/a91b5a4cb76570154e560bdea3138a425833ce8c))


### BREAKING CHANGES

* Install `@ionic/cli-framework-output` and import from it directly.





## [4.2.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.2.1...@ionic/cli-framework@4.2.2) (2020-08-26)

**Note:** Version bump only for package @ionic/cli-framework





## [4.2.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.2.0...@ionic/cli-framework@4.2.1) (2020-08-25)

**Note:** Version bump only for package @ionic/cli-framework





# [4.2.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.5...@ionic/cli-framework@4.2.0) (2020-06-02)


### Features

* **help:** formatBeforeInputSummary and formatAfterInputSummary ([70ac3ab](https://github.com/ionic-team/ionic-cli/commit/70ac3ab633dc7dd65a2ac344c81a01f7914597b8))





## [4.1.5](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.4...@ionic/cli-framework@4.1.5) (2020-05-12)


### Bug Fixes

* pin tslib to avoid "Cannot set property pathExists" error ([689e1f0](https://github.com/ionic-team/ionic-cli/commit/689e1f038b907356ef855a067a76d4822e7072a8))





## [4.1.4](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.3...@ionic/cli-framework@4.1.4) (2020-05-06)

**Note:** Version bump only for package @ionic/cli-framework





## [4.1.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.2...@ionic/cli-framework@4.1.3) (2020-04-29)

**Note:** Version bump only for package @ionic/cli-framework





## [4.1.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.1...@ionic/cli-framework@4.1.2) (2020-03-30)

**Note:** Version bump only for package @ionic/cli-framework





## [4.1.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.1.0...@ionic/cli-framework@4.1.1) (2020-03-03)

**Note:** Version bump only for package @ionic/cli-framework





# 4.1.0 (2020-02-11)


### Features

* **start:** add new list starter option ([#4315](https://github.com/ionic-team/ionic-cli/issues/4315)) ([1df44c1](https://github.com/ionic-team/ionic-cli/commit/1df44c1591f37b89f2b672857740edd6cb2aea67))





## [4.0.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.0.1...@ionic/cli-framework@4.0.2) (2020-02-10)

**Note:** Version bump only for package @ionic/cli-framework





## [4.0.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@4.0.0...@ionic/cli-framework@4.0.1) (2020-02-03)


### Bug Fixes

* **help:** use proper full command/namespace name, not alias ([e42efc6](https://github.com/ionic-team/ionic-cli/commit/e42efc6ad6ce48545fe3f106720a9aa14af478f5))





# [4.0.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.6...@ionic/cli-framework@4.0.0) (2020-01-25)


### chore

* require Node 10 ([5a47874](https://github.com/ionic-team/ionic-cli/commit/5a478746c074207b6dc96aa8771f04a606deb1ef))


### BREAKING CHANGES

* A minimum of Node.js 10.3.0 is required.





## [3.0.6](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.5...@ionic/cli-framework@3.0.6) (2020-01-13)

**Note:** Version bump only for package @ionic/cli-framework





## [3.0.5](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.4...@ionic/cli-framework@3.0.5) (2019-12-10)


### Bug Fixes

* **help:** make namespace/command groups unique when displaying ([32215b2](https://github.com/ionic-team/ionic-cli/commit/32215b27d4511bd8966bb07ba1663392f790336f))





## [3.0.4](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.3...@ionic/cli-framework@3.0.4) (2019-12-05)

**Note:** Version bump only for package @ionic/cli-framework





## [3.0.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.2...@ionic/cli-framework@3.0.3) (2019-11-25)

**Note:** Version bump only for package @ionic/cli-framework





## [3.0.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.1...@ionic/cli-framework@3.0.2) (2019-11-24)


### Bug Fixes

* fix parsing of command line options ([060f67c](https://github.com/ionic-team/ionic-cli/commit/060f67cf63d37662ae44c4ae952161464a5d553c))





## [3.0.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@3.0.0...@ionic/cli-framework@3.0.1) (2019-11-21)

**Note:** Version bump only for package @ionic/cli-framework





# [3.0.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.8...@ionic/cli-framework@3.0.0) (2019-10-14)


### Code Refactoring

* **prompts:** remove prompt support ([82241ef](https://github.com/ionic-team/ionic-cli/commit/82241ef7ddf8fdc6fc0db051a9acd0ed100c3fa8))


### BREAKING CHANGES

* **prompts:** This package no longer supports interactive prompts. See `@ionic/cli-framework-prompts`.





## [2.1.8](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.7...@ionic/cli-framework@2.1.8) (2019-10-14)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.7](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.6...@ionic/cli-framework@2.1.7) (2019-09-18)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.6](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.5...@ionic/cli-framework@2.1.6) (2019-08-28)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.5](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.4...@ionic/cli-framework@2.1.5) (2019-08-23)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.4](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.3...@ionic/cli-framework@2.1.4) (2019-08-14)


### Bug Fixes

* **help:** custom colors are not passed to SchemaHelpFormatter ([#4115](https://github.com/ionic-team/ionic-cli/issues/4115)) ([5634e9f](https://github.com/ionic-team/ionic-cli/commit/5634e9f))





## [2.1.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.2...@ionic/cli-framework@2.1.3) (2019-08-07)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.1...@ionic/cli-framework@2.1.2) (2019-07-09)

**Note:** Version bump only for package @ionic/cli-framework





## [2.1.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.1.0...@ionic/cli-framework@2.1.1) (2019-06-28)

**Note:** Version bump only for package @ionic/cli-framework





# [2.1.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.0.3...@ionic/cli-framework@2.1.0) (2019-06-21)


### Features

* **validators:** `combine` for combining validators into one ([bcef698](https://github.com/ionic-team/ionic-cli/commit/bcef698))





## [2.0.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.0.2...@ionic/cli-framework@2.0.3) (2019-06-18)

**Note:** Version bump only for package @ionic/cli-framework





## [2.0.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.0.1...@ionic/cli-framework@2.0.2) (2019-06-10)

**Note:** Version bump only for package @ionic/cli-framework





## [2.0.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@2.0.0...@ionic/cli-framework@2.0.1) (2019-06-05)

**Note:** Version bump only for package @ionic/cli-framework





# [2.0.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.7.0...@ionic/cli-framework@2.0.0) (2019-05-29)


### chore

* **output:** remove unused BottomBar stuff ([e2023d1](https://github.com/ionic-team/ionic-cli/commit/e2023d1))
* require Node 8 ([5670e68](https://github.com/ionic-team/ionic-cli/commit/5670e68))


### Features

* Command-Line Completions ([9f66512](https://github.com/ionic-team/ionic-cli/commit/9f66512))
* **help:** color refactor ([5938429](https://github.com/ionic-team/ionic-cli/commit/5938429))


### BREAKING CHANGES

* **output:** Remove `BottomBarOutputStrategy`
* A minimum of Node.js 8.9.4 is required.
* **help:** option/command/namespace groups are now `MetadataGroup`





<a name="1.7.0"></a>
# [1.7.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.6.3...@ionic/cli-framework@1.7.0) (2019-03-12)


### Features

* **help:** add flair for paid content ([e7978e2](https://github.com/ionic-team/ionic-cli/commit/e7978e2))




<a name="1.6.3"></a>
## [1.6.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.6.2...@ionic/cli-framework@1.6.3) (2019-03-06)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.6.2"></a>
## [1.6.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.6.1...@ionic/cli-framework@1.6.2) (2019-02-27)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.6.1"></a>
## [1.6.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.6.0...@ionic/cli-framework@1.6.1) (2019-02-15)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.6.0"></a>
# [1.6.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.5.3...@ionic/cli-framework@1.6.0) (2019-01-23)


### Features

* **help:** text/link footnotes for descriptions ([2c74d53](https://github.com/ionic-team/ionic-cli/commit/2c74d53))




<a name="1.5.3"></a>
## [1.5.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.5.2...@ionic/cli-framework@1.5.3) (2019-01-08)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.5.2"></a>
## [1.5.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.5.1...@ionic/cli-framework@1.5.2) (2019-01-07)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.5.1"></a>
## [1.5.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.5.0...@ionic/cli-framework@1.5.1) (2018-12-19)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.5.0"></a>
# [1.5.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.4.0...@ionic/cli-framework@1.5.0) (2018-11-27)


### Features

* **help:** weaken the color of deprecated commands and options ([66f48d8](https://github.com/ionic-team/ionic-cli/commit/66f48d8))
* **shell:** error for subprocesses that exit via signal ([3af1cee](https://github.com/ionic-team/ionic-cli/commit/3af1cee))




<a name="1.4.0"></a>
# [1.4.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.3.0...@ionic/cli-framework@1.4.0) (2018-11-20)


### Bug Fixes

* **config:** rewrite config for not found & syntax errors ([13298f1](https://github.com/ionic-team/ionic-cli/commit/13298f1))
* **terminal:** expand upon and fix Windows shell detection ([c3aa5a1](https://github.com/ionic-team/ionic-cli/commit/c3aa5a1)), closes [/github.com/ionic-team/ionic-cli/commit/dcc912d889011afd5944eaf4829bc8e5b4d0f4b6#commitcomment-31280556](https://github.com//github.com/ionic-team/ionic-cli/commit/dcc912d889011afd5944eaf4829bc8e5b4d0f4b6/issues/commitcomment-31280556)


### Features

* **help:** spec for customizing option help schema ([73830bc](https://github.com/ionic-team/ionic-cli/commit/73830bc))




<a name="1.3.0"></a>
# [1.3.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.2.0...@ionic/cli-framework@1.3.0) (2018-11-04)


### Bug Fixes

* **start:** fix stdio freezing issue on Windows ([#3725](https://github.com/ionic-team/ionic-cli/issues/3725)) ([a570770](https://github.com/ionic-team/ionic-cli/commit/a570770))


### Features

* **fn:** add function for resolving values from function series ([ac97f78](https://github.com/ionic-team/ionic-cli/commit/ac97f78))




<a name="1.2.0"></a>
# [1.2.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.1.1...@ionic/cli-framework@1.2.0) (2018-10-31)


### Bug Fixes

* **config:** write json file with ending newline ([dc3f2a5](https://github.com/ionic-team/ionic-cli/commit/dc3f2a5))
* **help:** filter out unnecessary global options ([7809c99](https://github.com/ionic-team/ionic-cli/commit/7809c99))
* **process:** keep node running for `sleepForever()` ([ea08f8d](https://github.com/ionic-team/ionic-cli/commit/ea08f8d))


### Features

* **namespace:** add `useAliases` option to `locate()` ([489617b](https://github.com/ionic-team/ionic-cli/commit/489617b))
* **object:** add `keysWithoutAliases()` method to `AliasedMap` ([f4807f4](https://github.com/ionic-team/ionic-cli/commit/f4807f4))
* **terminal:** detect windows shell ([dcc912d](https://github.com/ionic-team/ionic-cli/commit/dcc912d))




<a name="1.1.1"></a>
## [1.1.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.1.0...@ionic/cli-framework@1.1.1) (2018-10-05)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.1.0"></a>
# [1.1.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.7...@ionic/cli-framework@1.1.0) (2018-10-03)


### Features

* **shell:** accept pathed name ([7e6c713](https://github.com/ionic-team/ionic-cli/commit/7e6c713))
* **shell:** provide which utility for finding binaries ([4dbe922](https://github.com/ionic-team/ionic-cli/commit/4dbe922))




<a name="1.0.7"></a>
## [1.0.7](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.6...@ionic/cli-framework@1.0.7) (2018-09-05)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.0.6"></a>
## [1.0.6](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.5...@ionic/cli-framework@1.0.6) (2018-08-20)


### Bug Fixes

* **process:** catch and log errors in exit queue ([f3cd886](https://github.com/ionic-team/ionic-cli/commit/f3cd886))




<a name="1.0.5"></a>
## [1.0.5](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.4...@ionic/cli-framework@1.0.5) (2018-08-09)


### Bug Fixes

* **serve:** fix unclosed connection issue again ([#3500](https://github.com/ionic-team/ionic-cli/issues/3500)) ([1f0ef3b](https://github.com/ionic-team/ionic-cli/commit/1f0ef3b))




<a name="1.0.4"></a>
## [1.0.4](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.3...@ionic/cli-framework@1.0.4) (2018-08-07)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.0.3"></a>
## [1.0.3](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.2...@ionic/cli-framework@1.0.3) (2018-08-06)


### Bug Fixes

* **serve:** properly cleanup child processes ([#3481](https://github.com/ionic-team/ionic-cli/issues/3481)) ([38217bf](https://github.com/ionic-team/ionic-cli/commit/38217bf))
* **serve:** use 127.0.0.1 to attempt connections ([#3476](https://github.com/ionic-team/ionic-cli/issues/3476)) ([12c3f35](https://github.com/ionic-team/ionic-cli/commit/12c3f35))




<a name="1.0.2"></a>
## [1.0.2](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.1...@ionic/cli-framework@1.0.2) (2018-08-02)


### Bug Fixes

* **serve:** check all network interfaces for an available port ([30fd6ef](https://github.com/ionic-team/ionic-cli/commit/30fd6ef))




<a name="1.0.1"></a>
## [1.0.1](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.0...@ionic/cli-framework@1.0.1) (2018-07-30)




**Note:** Version bump only for package @ionic/cli-framework

<a name="1.0.0"></a>
# [1.0.0](https://github.com/ionic-team/ionic-cli/compare/@ionic/cli-framework@1.0.0-rc.13...@ionic/cli-framework@1.0.0) (2018-07-25)




**Note:** Version bump only for package @ionic/cli-framework
